/*
 * FileThread.java
 *
 * Created on 25. červenec 2007, 21:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sever;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.ServerSocket;
import java.net.Socket;

/**
 *
 * @author lubos
 */
public class FileThread extends Thread{
    
    protected Socket socket;
    protected Main main;
    protected PrintStream output;
    protected BufferedInputStream inputs;
    protected ListeningThread listeningThread;

    
    /** Creates a new instance of FileThread */
    public FileThread(Main main, Socket socket) {
        this.main = main; 
        this.socket = socket; 
    }
    
    public void setListeningThread(ListeningThread listeningThread){
        this.listeningThread = listeningThread;
    }
    
    public void run() {
        try {
            boolean zapis = false;
            String zprava3 = "";
            inputs = new BufferedInputStream(socket.getInputStream());
            output = new PrintStream(new BufferedOutputStream(socket.getOutputStream(),64*1024));

            StringBuffer radekBuf = new StringBuffer();
            int i = 1;
            boolean eof = false; 
            while(!eof) {
                
                radekBuf.setLength(0); 

                while ((i = inputs.read()) != '\n' && i > 0){
                    radekBuf.append((char)i);
                }
                
                eof = i==-1;
                
                String radek = radekBuf.toString().trim();
                System.out.println(this.toString() + " input data: "+radek);
                
                // parse commands
                if(radek.equals("")) {
                    continue; // skip emtpy row (e.g. if connection breaks                                         
                }  else if (radek.startsWith("GETFILE ")){
                    System.out.println("GETFILE in FileThread");
                    String fname = radek.substring(radek.indexOf('"')+1,radek.lastIndexOf('"'));
                    File file = new File("sharedfiles/" + fname);
                    InputStream fis = new BufferedInputStream(new FileInputStream(file));
                    long len = file.getAbsoluteFile().length();//Integer.parseInt(radek.substring(radek.lastIndexOf(' ')).trim());
                    int part;
                    output.print("FILE \"" + fname + "\" " + len + "\n");
                    output.flush();
                    while ((part = fis.read()) >= 0){
                        output.write(part);
                    }
                    output.flush();
                    System.out.println("File transfer complete...");
                } else if (radek.startsWith("FILE")){
                    // zjisti jmeno a delku dat
                    String name = radek.substring(radek.indexOf('"')+1,radek.lastIndexOf('"'));
                    int len = Integer.parseInt(radek.substring(radek.lastIndexOf(' ')).trim());
                    // ensure it doesn't contain bad characters
                    name = name.replace('/','_').replace('\\','_').replace('"','_');
                    String fname = "sharedfiles"+File.separator+name;
                    new File("sharedfiles").mkdir(); //  ensure sharedfiles exists
                    File file = new File(fname);
                    OutputStream os = new BufferedOutputStream(new FileOutputStream(file));
                    for(int y=0;y<len;y++) {
                        os.write(inputs.read());
                    }
                    os.close(); // nesmime zapomenout, nemusel by se ulozit cely!
                    main.commandToAll("SHARED FILE " + "\"" + name + "\" " + len);
                    ListeningThread.files.put(name,file);
                    listeningThread.fileOwner.put(name,file);
                    System.out.println("Dostal jsem soubor: "+name);
                }  else {
                    // TODO: implement other commands, sending texts and files
                    System.err.println("UNKNOWN COMMAND!!! "+radek);
                }
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            
        }
    }
    
}
