/*
 * ListeningThread.java
 *
 * Created on February 21, 2007, 12:23 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sever;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.HashMap;

/**
 *
 * @author aubrech
 */
public class ListeningThread extends Thread {
    public static final String COMMAND_MYNICK = "MYNICK";
    public static final String COMMAND_GETUSERS = "GETUSERS";
    public static final String COMMAND_MESSAGE = "MESSAGE";
    public static final String COMMAND_LISTFILES = "LISTFILES";
    public static final String COMMAND_FILE = "FILE";
    public static final String COMMAND_REFRESH = "REFRESH";
    public static final String COMMAND_GETFILE = "GETFILE";
    public static final String COMMAND_REFRESHFILES = "REFILES";
    public static final String COMMAND_DELETEFILE = "DELETEFILE";
    
    protected PrintStream output;
    protected BufferedInputStream inputs;
    
    protected String nick;
    
    protected Socket socket;
    
    protected Main main;
    
    /** mapa souboru: jmeno - soubor
     */
    public static HashMap<String, File> files = new HashMap<String, File>();
    public HashMap<String, File> fileOwner = new HashMap<String, File>();
    
    /** Creates a new instance of ListeningThread */
    public ListeningThread(Main main, Socket socket) {
        this.main = main;
        this.socket = socket;
        
    }
    
    public void run() {
        try {
            boolean zapis = false;
            String zprava3 = "";
            inputs = new BufferedInputStream(socket.getInputStream());
            output = new PrintStream(new BufferedOutputStream(socket.getOutputStream(),64*1024));
            // pro pridavani do stringu se pouziva StringBuffer kvuli rychlosti!!!
            StringBuffer radekBuf = new StringBuffer();
            int i = 1;
            boolean eof = false; // is end-of-file reached?
            while(!eof) {
                radekBuf.setLength(0); // clear buffer
                // read line
                while ((i = inputs.read()) != '\n' && i > 0){
                    //System.out.print((char)i);
                    radekBuf.append((char)i);
                }
                // check end-of-line mark (returns -1)
                eof = i==-1;
                
                String radek = radekBuf.toString().trim();
                System.out.println(this.toString() + " input data: "+radek);
                
                // parse commands
                if(radek.equals("")) {
                    continue; // skip emtpy row (e.g. if connection breaks
                }  else if(radek.startsWith(COMMAND_MYNICK+" ")){
                    nick = radek.substring(COMMAND_MYNICK.length()+1);
                    setName("listener to "+nick); // name the thread according to the nick
                    main.setNick(this,nick);
                } else if (radek.equalsIgnoreCase(COMMAND_REFRESH)){
                    main.commandToAll("GETUSERS");
                } else if (zapis == true){
                    if (radek.equalsIgnoreCase("!CMD_EOM!")){
                        zapis = false;
                        System.out.println("Zprava: "+zprava3);
                        continue;
                    } else{
                        zprava3 = zprava3 + "\r\n" + radek;
                        System.out.println("Zprava else: "+zprava3);
                    }
                } else if (radek.equalsIgnoreCase("REFILES")){
                     main.commandToAll("SENDFILELIST");
                     System.out.println("Sending name of files..."); 
                     for(String ffname : files.keySet()) {                        
                         main.commandToAll("UP-SHARED FILE " + "\"" + ffname + "\" "+files.get(ffname).length());//                        
                     }    
                     output.print("\n");                    
                     output.flush();
                     
                } else if (radek.equalsIgnoreCase("REDELFILES")){
                     System.out.println("Sending name of files..."); 
                     for(String ffname : files.keySet()) {                        
                         output.print("UP-SHARED FILE " + "\"" + ffname + "\" "+files.get(ffname).length()+"\n");// 
                         output.flush();
                     }    
                     output.print("\n");                    
                     output.flush();
                     
                } else if (radek.startsWith(COMMAND_DELETEFILE)){
                    String kteryFile = radek.substring(11,radek.length());
                    if (fileOwner.containsKey(kteryFile)){
                        files.get(kteryFile).delete();
                        files.remove(kteryFile);
                        fileOwner.remove(kteryFile);
                        main.commandToAll("WASDELETED");
                    }                                        
                } else if (radek.equalsIgnoreCase(COMMAND_GETUSERS)){
                    ArrayList<String> list = main.getNicks(this);
                    for(String client : list) {
                        output.print("NEWNICK "+client+"\n");
                    }
                    // an empty line at the end
                    output.print("\n");                    
                    output.flush();
                } else if (radek.startsWith(COMMAND_MESSAGE)){
                    // zjisti delku dat
                    int len = Integer.parseInt(radek.substring(COMMAND_MESSAGE.length()).trim());
                    StringBuffer msg = new StringBuffer();
                    for(int y=0;y<len;y++) {
                        msg.append((char)inputs.read());
                    }
                    main.sendToAll(msg.toString());
                    System.out.println("Dostal jsem zpravu: "+msg);
                    
                } else if (radek.startsWith("TABLE INSERT")){
                    //preposle vsem klientum
                    main.commandToAll(radek);
                    System.out.println(radek);              
                    
                } else if (radek.startsWith("GETFILE ")){
                    System.out.println("GETFILE in ListeningThread");
                    String fname = radek.substring(radek.indexOf('"')+1,radek.lastIndexOf('"'));
                    File file = new File("sharedfiles/" + fname);
                    InputStream fis = new BufferedInputStream(new FileInputStream(file));
                    long len = file.getAbsoluteFile().length();//Integer.parseInt(radek.substring(radek.lastIndexOf(' ')).trim());
                    int part;
                    output.print("FILE \"" + fname + "\" " + len + "\n");
                    while ((part = fis.read()) >= 0){
                        output.write(part);
                    }
                    output.flush();
                } else if (radek.startsWith(COMMAND_FILE)){
                    // zjisti jmeno a delku dat
                    String name = radek.substring(radek.indexOf('"')+1,radek.lastIndexOf('"'));
                    int len = Integer.parseInt(radek.substring(radek.lastIndexOf(' ')).trim());
                    // ensure it doesn't contain bad characters
                    name = name.replace('/','_').replace('\\','_').replace('"','_');
                    String fname = "sharedfiles"+File.separator+name;
                    new File("sharedfiles").mkdir(); //  ensure sharedfiles exists
                    File file = new File(fname);
                    OutputStream os = new BufferedOutputStream(new FileOutputStream(file));
                    for(int y=0;y<len;y++) {
                        os.write(inputs.read());
                    }
                    os.close(); // nesmime zapomenout, nemusel by se ulozit cely!
                    main.commandToAll("SHARED FILE " + "\"" + name + "\" " + len);
                    files.put(name,file);
                    fileOwner.put(name,file);
                    System.out.println("Dostal jsem soubor: "+name);
                } else if (radek.equalsIgnoreCase(COMMAND_LISTFILES)){
                    for(String fname : files.keySet()) {
                        output.print(fname+"\n");
                    }
                    // an empty line at the end
                    output.print("\n");
                    output.flush();
                } else {
                    // TODO: implement other commands, sending texts and files
                    System.err.println("UNKNOWN COMMAND!!! "+radek);
                }
            }
        } catch (IOException ex) {
            main.reportError(this, ex);
            ex.printStackTrace();
        } finally {
            for(String klic: fileOwner.keySet()){
                files.get(klic).delete();
                files.remove(klic);
            }
            main.removeClient(this);
            main.commandToAll("GETUSERS");               
        }
    }
    
    public String getNick() {
        return nick;
    }
    
    public PrintStream getOutput() {
        return output;
    }
}
