package sever;
import java.net.*;
import java.io.*;
import java.util.ArrayList;

public class Main {
    // pole klientu
    protected ArrayList<ListeningThread> clients = new ArrayList<ListeningThread>();
    
    public Main() {
        ServerSocket socket1 = null;
        ServerSocket socket2 = null;
        try{
            socket1 = new ServerSocket(10080);
            socket2 = new ServerSocket(10081);
            //SocketAddress addr = new InetSocketAddress(InetAddress.getByName("127.0.0.1"), 12121);
            //socket1.bind(addr);
            String radek = new String();
            String co = new String();
            int pocet_spojeni = 0;
            
            while(true) {
                System.out.println("Listening...");
                
                Socket socket = socket1.accept();
                ListeningThread newThread = new ListeningThread(this, socket);
                clients.add(newThread);
                newThread.start();
                System.out.println("new thread launched");
                
                
                Socket fileSocket = socket2.accept();
                FileThread newFileThread = new FileThread(this, fileSocket);
                newFileThread.setListeningThread(newThread);
                newFileThread.start();
                System.out.println("FileThread launched");
            }
            
            
        } catch(Exception e) {
            e.printStackTrace();
        }
        
        finally {
            if(socket1 != null){
                try {
                    socket1.close();
                } catch(IOException e) {
                }
            }
        }
    }
    
    
    public static void main(String[] args) {
        // simply start the server
        new Main();
    }
    
    public synchronized void setNick(ListeningThread listeningThread, String nick) {
        System.out.println("somebody "+listeningThread+" changed nick to "+nick);
        // TODO: send this message to other users
    }
    
    public void reportError(ListeningThread listeningThread, IOException ex) {
        System.out.println("somebody "+listeningThread+" reported error: "+ex.getMessage());
    }
    
    /** return a list of all nicks (others than who asks)
     */
    public synchronized ArrayList<String> getNicks(ListeningThread whoAsks) {
        ArrayList<String> list = new ArrayList<String>();
        for(ListeningThread client : clients) {
            //if(client!=whoAsks){
            list.add(client.getNick());
        }
        return list;
    }
    
    /** remove a client
     */
    public synchronized void removeClient(ListeningThread toRemove) {
        clients.remove(toRemove);
    }
    
    /** send a message to all clients
     */
    public synchronized void sendToAll(String msg) {
        for(ListeningThread client : clients) {
            PrintStream print = client.getOutput();
            print.print(ListeningThread.COMMAND_MESSAGE+" "+msg.length()+"\n");
            print.print(msg);
            print.flush();
        }
    }
    
    /** send a command to all clients
     */
    public synchronized void commandToAll(String msg) {
        for(ListeningThread client : clients) {
            PrintStream print = client.getOutput();
            print.print(msg+"\n");
            print.flush();
        }
    }
    
}
